local DAY_LENGTH_MULTIPLIER = 3 -- (integer) Controls how long daytime will be. Set to 1 for default, vanilla length (3.5 minutes).
local NIGHT_LENGTH_MULTIPLIER  = 3 -- (integer) Same as above but for the night.


script.on_init(function()
	global.counter = global.counter or 0

	if global.freeze_state == nil then global.freeze_state = false end
end)

script.on_event(defines.events.on_tick, function(event)
	local tick = event.tick
	if not game.surfaces.nauvis.always_day and tick % 4 == 0 then
		local dt = game.surfaces.nauvis.daytime
		local extension_multiplier = (dt > 0.75 or dt < 0.25) and DAY_LENGTH_MULTIPLIER or NIGHT_LENGTH_MULTIPLIER
		if global.counter == 0 then
			global.counter = 1
			if global.freeze_state then
				game.surfaces.nauvis.freeze_daytime(false)
				global.freeze_state = false
			end
		elseif global.counter < extension_multiplier then
			global.counter = global.counter + 1
			if not freeze_state then
				game.surfaces.nauvis.freeze_daytime(true)
				global.freeze_state = true
			end
		else
			global.counter = 0
		end
	end
end)